'use strict';
const e = React.createElement;

Number.prototype.format = function(n, x, s, c) {
    var re = '\\d(?=(\\d{' + (x || 3) + '})+' + (n > 0 ? '\\D' : '$') + ')',
        num = this.toFixed(Math.max(0, ~~n));
    return (c ? num.replace('.', c) : num).replace(new RegExp(re, 'g'), '$&' + (s || ','));
};
function Passenger(props){
    let [data,setData] = React.useState({});
    const [fullname,setFullname] = React.useState("");
    const [age,setAge] = React.useState("");
    const [weight,setWeight] = React.useState("");
    const [nationality,setNationality] = React.useState("");
    let handleChange = (e)=>{
        
        let {name,value} = e.target;
        //console.log(e.target.name);
        data[name] = value;
        if(name =='nationality'){
            setNationality(value);
        }
        if(name == 'fullname'){
            setFullname(value);
        }
        if(name == 'age'){
            setAge(value);
        }
        if(name == 'weight'){
            setWeight(value);
        }
        setData(data);
        updatePassenger(data);
    }
    let updatePassenger = (obj)=>{
        //console.log(data);
        /*
        if(!data.fullname && data.fullname === ""){
            if(props.delDataPassenger)
                props.delDataPassenger(props.index);
            return;
        }
        if(!data.age && data.age === ""){
            if(props.delDataPassenger)
                props.delDataPassenger(props.index);
            return;
        }
        if(!data.weight && data.weight === ""){
            if(props.delDataPassenger)
                props.delDataPassenger(props.index);
            return;
        }
        if(!data.nationality && data.nationality === ""){
            if(props.delDataPassenger)
                props.delDataPassenger(props.index);
            return;
        }
        if( data.fullname && data.age && data.weight && data.nationality){
            if(props.updateDataPassenger){
                props.updateDataPassenger(props.index,data);
            }
        }*/
        if(props.updateDataPassenger){
            props.updateDataPassenger(props.index,data);
        }
    }
    return (
        <div>
            <div className="column one" align="left">
			    <span className="form-label">Passenger {parseInt(props.index) + 1} <span className="required" title="required">*</span></span> 
			</div>
            <div className="column one-forth">
                <input placeholder="Full Name" onChange={handleChange} type="text" name="fullname" value={fullname} size="27" aria-required="true" aria-invalid="false" />
            </div>
            <div className="column one-forth">
                <input placeholder="Age" type="text" name="age" onChange={handleChange} value={age} size="26" aria-required="true" aria-invalid="false" />
            </div>
            <div className="column one-forth">
                <input placeholder="Weight (kg.)" type="text" name="weight" onChange={handleChange} value={weight} size="26" aria-required="true" aria-invalid="false" />
            </div>
            <div className="column one-forth">
                
                            <select value={nationality} name="nationality" onChange={handleChange} className="form-control" style={{width:"100%"}} >
                                <option disabled={true} value="">Nationality</option>
                                {
                                    (props.nationalities) && (props.nationalities.map((item,key)=>{
                                        return (<option key={key} value={item}>{item}</option>);
                                    }))
                                }
                            </select>
                            <span className="select-arrow"></span>
            </div>
        </div>
    )
}
async function postData(url = '', data = {}) {
    // Default options are marked with *
    const response = await fetch(url, {
      method: 'POST', // *GET, POST, PUT, DELETE, etc.
      mode: 'cors', // no-cors, *cors, same-origin
      cache: 'no-cache', // *default, no-cache, reload, force-cache, only-if-cached
      credentials: 'same-origin', // include, *same-origin, omit
      headers: {
        'Content-Type': 'application/json'
        // 'Content-Type': 'application/x-www-form-urlencoded',
      },
      redirect: 'follow', // manual, *follow, error
      referrerPolicy: 'no-referrer', // no-referrer, *no-referrer-when-downgrade, origin, origin-when-cross-origin, same-origin, strict-origin, strict-origin-when-cross-origin, unsafe-url
      body: JSON.stringify(data) // body data type must match "Content-Type" header
    });
    return response.json(); // parses JSON response into native JavaScript objects
}
const PayPalButton = paypal.Buttons.driver("react", { React, ReactDOM });
class Booking extends React.Component {
    constructor(props){
        super(props)
        this.state = {
            nationalities : null,
            submit : false,
            error : undefined,
            flightdate : "",
            flightdate_altenate : "",
            num_of_adult : 1,
            num_of_child : 0,
            flight_type : 0,
            private_type : 0,
            promotion_code:"",
            discount : 0,
            use_promo : false,
            total_price : 0,
            price:0,
            discount : 0,
            caltural_activity : 0,
            contact_title : "",
            contact_fullname : "",
            contact_email : "",
            contact_phone : "",
            contact_hotel : "",
            contact_roomno : "",
            passengers : [],
            agreement : false,
            note : "",
            open : false,
            paypalApproved:false,
            reviewState : false,
            reviewData :null,/* {
                bookinginfo : {
                    flightdate : "2021-12-10",
                    flightdate_altenate : "2021-12-15",
                    num_of_adult : 2,
                    num_of_child : 2,
                    flighttype : {
                        "id" : 1,
                        "name" : "CNX-01 - Chiang Mai - Shared basket",
                        "price_adult" : 100,
                        "price_child" : 50
                    },
                    privatetype : {
                        "id" : 1,
                        "name" : "Flower Bouquet"
                    },
                    calturalActivity : {
                        "id":0,
                        "name":"NO",
                        "price" : 0
                    },
                    total_price : 50000,
                    discount :25000,
                    promotion : {
                        "id" : 1,
                        "code" : "11939774",
                        "discount" : 50,
                        "discount_type" : "percent_of_total",
                        "desc" : "discount ${discount} % of total price"
                    },
                    price : 25000
                },
                contactinfo : {
                    title : "Mr.",
                    fullname : "Direk Prama",
                    email : "alek.pr@gmail.com",
                    phone : "0814414183",
                    hotel :  "",
                    roomno :  ""
                },
                passengers : [
                    {
                        fullname : "Direk Prama",
                        age : 39,
                        weight : 70,
                        nationality : "Thai"
                    },
                    {
                        fullname : "Direk Prama2",
                        age : 39,
                        weight : 70,
                        nationality : "Thai"
                    }
                ],
                note : "TEST"
            }*/
        }
        this.handleChange = this.handleChange.bind(this);
        this.applyPromoCode = this.applyPromoCode.bind(this);
        this.calculate = this.calculate.bind(this);
        this.updateDataPassenger = this.updateDataPassenger.bind(this);
        this.delDataPassenger = this.delDataPassenger.bind(this);
        this.onSubmitForm = this.onSubmitForm.bind(this);
        this.onApprove = this.onApprove.bind(this);
    }
    calculate(){
        let {flight_type,FlightTypes,num_of_adult,num_of_child,CalturalActivitys,caltural_activity,use_promo,discount,promotion} = this.state;
        if(parseInt(flight_type) > 0){
            let total_price = 0;
            let price = 0;
            let flighttype = _.find(FlightTypes,(o)=>{
                return o.id === parseInt(flight_type);
            });

            if(flight_type == 2 || flight_type == 4){
                total_price += flighttype.price_adult;
            }else{
                if(flighttype.price_adult && num_of_adult){
                    total_price += flighttype.price_adult * parseInt(num_of_adult);
                }
                if(flighttype.price_child && num_of_adult){
                    total_price += flighttype.price_child * parseInt(num_of_child);
                }
            }
            
            let CalturalActivity = _.find(CalturalActivitys,(o)=>{
                return o.id === parseInt(caltural_activity);
            });
            if(CalturalActivity){
                total_price += (CalturalActivity.price * (num_of_adult+num_of_child));
            }
            if(use_promo && promotion){
                if(promotion.discount_type === "discount_price"){
                    discount = promotion.discount;
                }
                if(promotion.discount_type === "percent_of_total"){
                    discount = (promotion.discount * total_price)/100;
                }
                
            }
            price = total_price - discount;
            this.setState({price,total_price,discount});
        }else{
            this.setState({price:0,total_price:0,discount:0});
        }
    }
    componentDidMount(){
        fetch(`js/config.json`)
        .then(response => response.json())
        .then(data => {
            if(data.FlightTypes){
                this.setState({FlightTypes:data.FlightTypes})
            }
            if(data.PrivateTypes){
                this.setState({PrivateTypes:data.PrivateTypes})
            }
            if(data.CalturalActivitys){
                this.setState({CalturalActivitys:data.CalturalActivitys})
            }
            if(data.PromotionCodes){
                this.setState({PromotionCodes:data.PromotionCodes});
            }
        });

        fetch(`js/nationalities.json`)
        .then(response => response.json())
        .then(data => {
            //console.log(data);
            this.setState({nationalities:data})
        });
    }
    componentWillUnmount(){

    }
    handleChange(e){
        let {name,value} = e.target;
        //console.log([name,value]);
        this.setState({[name]:value});
        if(name === "flight_type"){
            if(!(value == 4 || value == 3)){
                this.setState({
                    //private_type : 0,
                    caltural_activity : 0
                });
            }
            if(!(value == 2 || value == 4)){
                this.setState({
                    private_type : 0,
                    //num_of_child : 0
                });
            }
            if((value == 2 || value == 4)){

                this.setState({
                    num_of_adult : 2,
                    num_of_child : 0
                });
            }
        }
        setTimeout(()=>{
            this.calculate();
        },600)
    }
    applyPromoCode(){
        //console.log("use promo code");
        let {use_promo,discount,promotion_code,PromotionCodes} = this.state;
        if(!use_promo){
            let promotion = _.find(PromotionCodes,(o)=>{
                return o.code === promotion_code;
            })
            if(promotion){
                this.setState({promotion});
                this.setState({use_promo:true});
                setTimeout(()=>{
                    this.calculate();
                },600)
            }
        }
    }
    updateDataPassenger(index,data){
        let {passengers} = this.state;
        passengers[index] = data;
        //this.setState({passengers});
        //console.log(passengers);
    }
    delDataPassenger(index){
        let {passengers} = this.state;
        passengers[index] = undefined;
        //this.setState({passengers});
        //console.log(passengers);
    }
    alert(message){
        $.alert({
            title: 'Message Box!',
            content: message,
            boxWidth : '450px',
            useBootstrap : false
        });
    }
    onSubmitForm(){
        let {
            flightdate,flightdate_altenate,num_of_adult,num_of_child,flight_type,
            private_type,caltural_activity,use_promo,promotion,promotion_code,
            contact_title,contact_fullname,agreement,note,contact_email,contact_phone,
            contact_hotel,contact_roomno,passengers,FlightTypes,CalturalActivitys,PrivateTypes,submit,discount,price,total_price
        } = this.state;
        if(!flightdate){
            this.alert("Please select flight date.")
            return;
        }
        if(flight_type == 0){
            this.alert("Please select flight type.")
            return;
        }
        if(contact_title == 0){
            this.alert("Please select title.")
            return;
        }
        if(contact_fullname == ""){
            this.alert("Please enter fullname.")
            return;
        }
        if(contact_email == ""){
            this.alert("Please enter email.")
            return;
        }
        if(contact_phone == ""){
            this.alert("Please enter phone.")
            return;
        }
        /*if(contact_hotel == ""){
            this.alert("Please enter hotel.")
            return;
        }
        if(contact_roomno == ""){
            this.alert("Please enter room no.")
            return;
        }*/
        //console.log(passengers);
        let total_passenger = parseInt(num_of_adult)+parseInt(num_of_child);
        let count =0;
        _.each(passengers,(v,k)=>{
            if(v == undefined){
                return;
            }
            if(v.fullname == undefined || v.fullname ==""){
                return;
            }
            if(v.age == undefined || v.age ==""){
                return;
            }
            if(v.weight == undefined || v.weight ==""){
                return;
            }
            if(v.nationality == undefined || v.nationality ==""){
                return;
            }
            
            count++;
        })
        if(total_passenger !== count){
            this.alert("Please enter passenger data.")
            return;
        }

        if(!agreement){
            this.alert("Please agree to the Terms and Conditions.")
            return;
        }

        if(!submit){
            //let total_price = 0;
            //let price = 0;
            let flighttype = _.find(FlightTypes,(o)=>{
                return o.id === parseInt(flight_type);
            });
            let privatetype = _.find(PrivateTypes,(o)=>{
                return o.id === parseInt(private_type);
            });
            let CalturalActivity = _.find(CalturalActivitys,(o)=>{
                return o.id === parseInt(caltural_activity);
            });
            /*if(flighttype.price_adult && num_of_adult){
                total_price += flighttype.price_adult * parseInt(num_of_adult);
            }
            if(flighttype.price_child && num_of_adult){
                total_price += flighttype.price_child * parseInt(num_of_child);
            }
            
            if(CalturalActivity){
                total_price += CalturalActivity.price;
            }
            if(use_promo && promotion){
                if(promotion.discount_type === "discount_price"){
                    discount = promotion.discount;
                }
                if(promotion.discount_type === "percent_of_total"){
                    discount = (promotion.discount * total_price)/100;
                }
                price = total_price - discount;
            }else{
                price = total_price;
            }*/

            let data = {
                bookinginfo : {
                    flightdate : flightdate,
                    flightdate_altenate : flightdate_altenate,
                    num_of_adult : num_of_adult,
                    num_of_child : num_of_child,
                    flighttype : flighttype,
                    privatetype : privatetype,
                    calturalActivity : CalturalActivity,
                    total_price : total_price,
                    discount :discount,
                    promotion : promotion,
                    price : price
                },
                contactinfo : {
                    title : contact_title,
                    fullname : contact_fullname,
                    email : contact_email,
                    phone : contact_phone,
                    hotel : contact_hotel || "",
                    roomno : contact_roomno || ""
                },
                passengers : passengers,
                note : note
            };

            this.setState({submit:true});

            //console.log(data);
            
            postData('api/booking.php', data)
            .then(response => {
                //console.log(response); // JSON data parsed by `response.json()` call
                if(response.status){
                    //this.alert(response.message);
                    /*
                    this.setState({
                        submit : false,
                        error : undefined,
                        flightdate : undefined,flightdate_altenate : undefined,
                        num_of_adult : 0,
                        num_of_child : 0,
                        flight_type : 0,
                        private_type : 0,
                        promotion_code:"",
                        discount : 0,
                        use_promo : false,
                        total_price : 0,
                        caltural_activity : 0,
                        contact_title : "",
                        contact_fullname : "",
                        contact_email : "",
                        contact_phone : "",
                        contact_hotel : "",
                        contact_roomno : "",
                        passengers : [],
                        agreement : false,
                        note : ""
                    });
                    setTimeout(()=>{
                        this.setState({num_of_adult : 1});
                    },300)
                    */
                    this.setState({submit:false,reviewState:true,reviewData:response.data});
                }else{
                    this.alert(response.message);
                }
            });
            
        }
        

        
    }
    createOrder(data, actions) {
        //console.log(data)
        return actions.order.create({
          purchase_units: [
            {
              amount: {
                value: data.bookinginfo.price,
              },
            },
          ],
        });
    }
    
    onApprove(data, actions) {
        let _this = this;
        postData('api/capture.php', data)
            .then(response => {
                console.log(response); // JSON data parsed by `response.json()` call
                if(response.status){
                    _this.setState({paypalApproved:true});
                    actions.order.capture();
                    _this.setState({submit:false,reviewState:true,reviewData:response.data});
                }else{
                    _this.alert(response.message);
                }
            });
        
    }
    render() {
        let {flightdate,flightdate_altenate,
            num_of_adult,num_of_child,FlightTypes,flight_type,PrivateTypes,private_type,
            CalturalActivitys,caltural_activity,promotion_code,total_price,use_promo,price,nationalities,
            contact_title,contact_fullname,agreement,note,contact_email,contact_phone,contact_hotel,contact_roomno,submit,open,reviewData,reviewState,paypalApproved} = this.state;
        if(!FlightTypes || !PrivateTypes || !CalturalActivitys || !nationalities){
            return (<div>Loading....</div>)
        }
        //console.log(document.html);
        if(open){
            document.documentElement.style.overflow = "hidden";
        }else{
            document.documentElement.style.overflow = "auto";
        }

        let passengers_el = [];
        for (let i = 0; i < (parseInt(num_of_adult)+parseInt(num_of_child)); i++) {
            passengers_el.push(<Passenger key={i} index={i} updateDataPassenger={this.updateDataPassenger} delDataPassenger={this.delDataPassenger} nationalities={nationalities} />)
        }


        if(reviewState == false){
            return (
                <div>
                    <form autoComplete="off">
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Flight Date</span> <span className="required" title="required">*</span>
                            <input onChange={this.handleChange} value={flightdate} placeholder="Flight Date" type="date" name="flightdate" style={{width:"100%"}} aria-required="true" aria-invalid="false" />
                        </div>
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Flight Date (Altenate)</span>
                            <input onChange={this.handleChange} value={flightdate_altenate} placeholder="Flight Date" type="date" name="flightdate_altenate"  style={{width:"100%"}} aria-required="true" aria-invalid="false" />
                        </div>
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Number of Adult</span> <span className="required" title="required">*</span>
                            <select value={num_of_adult} name="num_of_adult" onChange={this.handleChange} className="form-control" style={{width:"100%"}} >
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option disabled={(flight_type == 2 || flight_type == 4)} value="3">3</option>
                                <option disabled={(flight_type == 2 || flight_type == 4)} value="4">4</option>
                                <option disabled={(flight_type == 2 || flight_type == 4)} value="5">5</option>
                                <option disabled={(flight_type == 2 || flight_type == 4)} value="6">6</option>
                                <option disabled={(flight_type == 2 || flight_type == 4)} value="7">7</option>
                                <option disabled={(flight_type == 2 || flight_type == 4)} value="8">8</option>
                            </select>
                            <span className="select-arrow"></span>
                        </div>
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Number of Child (5-11 Yrs.)</span>
                            <select value={num_of_child} disabled={(flight_type == 2 || flight_type == 4)} name="num_of_child" onChange={this.handleChange} className="form-control" style={{width:"100%"}} >
                                <option value="0">none</option>
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                            </select>
                            <span className="select-arrow"></span>
                        </div>
                        <div className="column one" align="left">
                            <span className="form-label">Flight Type : </span> 
                            <span className="required" title="required">*</span>
                            <abbr className="" title="see more detail of flights"><a href="#">more detail</a></abbr>
                            <select className="form-control" name="flight_type" onChange={this.handleChange} value={flight_type} >
                                <option value="0">Select Your Flight Type</option>
                                {
                                    FlightTypes.map((FlightType,idx)=><option key={`flight-k-`+idx} value={FlightType.id}>{FlightType.name}</option>)
                                }
                            </select>
                        </div>
                        <div className="column one-second" align="left">
                            <span className="form-label">For Private Type, you can select one the followings : </span>
                            <select className="form-control" disabled={!(flight_type == 2 || flight_type == 4)} onChange={this.handleChange} value={private_type} name="private_type">
                                <option value="0">No</option>
                                {
                                    PrivateTypes.map((PrivateType,idx)=><option key={`flight-k-`+idx} value={PrivateType.id}>{PrivateType.name}</option>)
                                }
                            </select>
                        </div>
                        <div className="column one-second" align="left">
                            <span className="form-label">For Chiang Rai, you can add "CULTURAL ACTIVITY" : </span>
                            <select className="form-control" disabled={!(flight_type == 4 || flight_type == 3)} value={caltural_activity} onChange={this.handleChange} name="caltural_activity">
                                {
                                    CalturalActivitys.map((CalturalActivity,idx)=><option key={`flight-k-`+idx} value={CalturalActivity.id}>{CalturalActivity.name}</option>)
                                }
                            </select>
                        </div>
        
                        <div className="column one-forth">
                            <input placeholder="Promo Code" readOnly={use_promo} type="text" name="promotion_code" value={promotion_code} onChange={this.handleChange} size="26" aria-required="true" aria-invalid="false" />
                        </div>
                        <div className="column one-forth">
                            <input disabled={use_promo} onClick={this.applyPromoCode} type="button" value="Apply Coupon" />
                        </div>
        
                        <div className="column one" align="left">
                            <div className="idea_box">
                                <div className="icon">
                                    <i className="icon-heart-fa"></i>
                                </div>
                            <div className="desc">Total Price is <strong>{price.format(0,3,",")}</strong> THB</div>
                            </div>
                        </div>
        
        
                        <div className="column one" align="left">
                            <span className="form-label">Booking Contact Information </span> 
                        </div>
                        <div className="column one-fourth">
                            <select className="form-control" onChange={this.handleChange} value={contact_title} name="contact_title">
                                <option value="">Title</option>
                                <option value="Mr">Mr</option>
                                <option value="Mrs">Mrs</option>
                                <option value="Miss">Miss</option>
                                <option value="Ms">Ms</option>
                            </select>
                        </div>
                        <div className="column three-fourth">
                            <input placeholder="Full Name" type="text" name="contact_fullname" onChange={this.handleChange} value={contact_fullname} size="" aria-required="true" aria-invalid="false" />
                        </div>
                        <div className="column one-fourth">
                            <input placeholder="Your E-Mail" type="text" name="contact_email" onChange={this.handleChange} value={contact_email} size="40" aria-required="true" aria-invalid="false" />
                        </div>
                        <div className="column one-fourth">
                            <input placeholder="Your Phone Number" type="text" name="contact_phone" onChange={this.handleChange} value={contact_phone} size="40" aria-required="true" aria-invalid="false" />
                        </div>
                        <div className="column one-fourth">
                            <input placeholder="Hotel Name" type="text" name="contact_hotel" onChange={this.handleChange} value={contact_hotel}  size="25" aria-required="false" aria-invalid="false" />
                        </div>
                        <div className="column one-fourth">
                            <input placeholder="Room Number" type="text" name="contact_roomno" onChange={this.handleChange} value={contact_roomno} size="25" aria-required="false" aria-invalid="false" />
                        </div>
                        {passengers_el}
                        
                        <div className="column one" align="left">
                            <span className="form-label">Other Requirements / Notes <span className="required" title="required"></span></span> 
                        </div>
                        <div className="column one">
                            <textarea placeholder="Other Requirements / Notes" name="note" onChange={this.handleChange} style={{width:"100%"}} rows="5" aria-invalid="false" value={note}></textarea>
                        </div>						
                                                                
                        <div className="column one" align="left">
                            <input type="checkbox" name="agreement" onChange={(e)=>{
                                let {name,checked} = e.target;
                                if(checked){
                                    this.setState({open:true});
                                }else {
                                    this.setState({[name]:checked});
                                }
                                //this.setState({[name]:checked});
                            }} value={agreement} checked={agreement} />
                            <span>I have read and agree to the Terms and Conditions.</span> 
                        </div>
                        
                        <div className="column one">									
                            <input disabled={!agreement} onClick={this.onSubmitForm} type="button" value="Confirm Booking" />
                        </div>
                        
                        
                    </form>
        
                    {
                        (open) && (
                            <div>
                                <div className="mfp-bg mfp-ready"></div>
                    <div className="mfp-wrap  mfp-close-btn-in mfp-auto-cursor mfp-ready" tabIndex="-1" style={{overflow: 'hidden auto'}}>
                        <div className="mfp-container mfp-s-ready mfp-inline-holder">
                            <div className="mfp-content" style={{backgroundColor:'#fff'}}>
                                <div className="terms-condition">
                                    <div className="terms-condition-content">
                                        <h4>Flight Terms and Conditions</h4>
                                        <div>
                                            <ul>
                                            <li>Passengers must call in upon arrival your hotel in Chiang Rai (Customer Service: 091 424 1446 or 089 6851188) between 8:00 am to 5:.00 pm. Or email at info@balloonchiangrai.com</li>
                                            <li>Passengers are recommended to wear comfortable clothing and covered shoes.</li>
                                            <li>Extra Clothing is required for pool and farming activity.</li>
                                            <li>Passengers who have any known medical condition such as epilepsy, recent surgery or other condition which can affect your ability to fly or assist the crew must be disclosed at the time of booking, and to the pilot on the day of your flight.</li>
                                            <li>Pregnant women are not allowed to fly.</li>
                                            <li>Children at age of 12 years or over 137cm tall (4 feet 6 inches) need to be accompanied by a paying adult. When booking for such children, please make sure you also make a corresponding booking for an accompanying adult.</li>
                                            <li>Passengers who weigh above 125kg/280 pounds will be required to pay 100% surcharge of the ticket price. On the flight day, your weight will be taken, and if it is above 125kg/280 pounds, you will be required to pay the surcharge, or refused the flight (if the total weight for the balloon & passengers exceed the permissible weight for flight), & no refund or alternate flights will be offered.</li>
                                            <li>Balloon ChiangRai will not be liable for illness or injury due to any undisclosed condition or failure to comply with any reasonable instructions given by the pilot, crew or company representatives.</li>
                                            <li>The pilot in command is legally responsible for the safety of all passengers at all times connected with the flight. He or she has the absolute right to refuse passengers for any reason if it is considered their carriage may endanger the flight or other passengers.</li>
                                            <li>Passengers must pay full attention to the safety briefing given by the pilot in command before the launch of the balloon, and questions should be put to pilot if the briefing is not understood or unclear.</li>
                                            <li>The pilot’s decision is final on all matters, and he or she has full authority over passengers and crew who are to fully comply with his or her instructions or orders.</li>
                                            <li>Balloon ChiangRai reserves the right to cancel or delay flights, and change rendezvous and launch sites at short notice, to achieve safe and successful flights. The company is not liable for any ensuing loss or inconvenience.</li>
                                            <li>Balloon ChiangRai has comprehensive international insurance cover for all passengers and third party’s liabilities.</li>
                                            <li>Balloon ChiangRai shall not be responsible for any loss or damage to personal effects taken on flights and will not accept any liabilities for such losses or damages.</li>
                                            <li>Flights cancelled by Balloon ChiangRai for safety reasons, unfavorable weather conditions, or operational difficulties will be refunded.  All direct payments to or via our website will be refunded within 1-3 days. For all other bookings made through tour agents, passengers must contact the respective agent to expedite their refunds.</li>
                                            <li>Balloon ChiangRai reserves the right to revise or modify any terms & conditions or rates due to changes in market conditions, at any point in time, without giving any prior notice. However, for confirmed reservation and bookings, they will be kept at the rates and terms prevailing at the time of booking.</li>
                                            </ul>
                                            <div className="button-accept-container">
                                                <a onClick={(e)=>{
                                                    this.setState({agreement:true,open:false});
                                                }}><span>ACCEPT TERM & CONDITIONS</span></a>
                                            </div>
                                        </div>
                                    </div>
                                    <button onClick={(e)=>{
                                        this.setState({open:false});
                                    }} title="Close (Esc)" type="button" className="mfp-close">×</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                            </div>
                        )
                    }
                    
                    
        
                    </div>
            )
        }

        if(reviewState == true && reviewData){
            //console.log(reviewData.passengers);
            return (
                <div className="review-container">
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Flight Date</span> <span className="required" title="required"></span>
                            <p>{reviewData.bookinginfo.flightdate}</p>
                        </div>
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Flight Date (Altenate)</span>
                            <p>{reviewData.bookinginfo.flightdate_altenate}</p>
                            
                        </div>
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Number of Adult</span> <span className="required" title="required">*</span>
                            <p>{reviewData.bookinginfo.num_of_adult}</p>
                           
                        </div>
                        <div className="column one-fourth" align="left">
                            <span className="form-label" style={{textOverflow:'ellipsis',whiteSpace:'nowrap'}}>Number of Child (5-11 Yrs.)</span>
                            <p>{reviewData.bookinginfo.num_of_child}</p>
                            
                        </div>
                        <div className="column one" align="left">
                            <span className="form-label">Flight Type : </span> 
                            <span className="required" title="required"></span>
                            <p>{reviewData.bookinginfo.flighttype.name}</p>
                        </div>
                        
                        <div className="column one-second" align="left">
                            <span className="form-label">For Private Type, you can select one the followings : </span>
                            {
                            (reviewData.bookinginfo.privatetype) && (
                                <p>{reviewData.bookinginfo.privatetype.name}</p> 
                            )
                            }
                            
                        </div>
                        <div className="column one-second" align="left">
                            <span className="form-label">For Chiang Rai, you can add "CULTURAL ACTIVITY" : </span>
                            {
                                (reviewData.bookinginfo.calturalActivity) && (
                                    <p>{reviewData.bookinginfo.calturalActivity.name}</p>
                                )
                            }
                            
                        </div>
                        <div className="column one" align="left">
                            <span className="form-label">Booking Contact Information </span> 
                            <p>{reviewData.contactinfo.title} {reviewData.contactinfo.fullname}</p>
                            <dl>
                            <dt>Email</dt>
                            <dd>{reviewData.contactinfo.email}</dd>
                            <dt>Mobile</dt>
                            <dd>{reviewData.contactinfo.phone}</dd>
                            <dt>Hotel</dt>
                            <dd>{reviewData.contactinfo.hotel}</dd>
                            <dt>Room No.</dt>
                            <dd>{reviewData.contactinfo.roomno}</dd>
                            </dl>
                        </div>
                        <div className="column one" align="left">
                            
                            <div className="passenger-detail">

                                {
                                    (reviewData.passengers) && reviewData.passengers.map((passenger,key)=>{
                                        return (
                                            <div key={key} className="table">
                                                <div className="row">
                                                    <div className="cell">
                                                        <p className="form-label">Passenger {(key+1)} </p> 
                                                    </div>
                                                </div>
                                                <div className="row">
                                                    <div className="cell">
                                                        <p><b>Name</b> : {passenger.fullname}</p>
                                                    </div>
                                                    <div className="cell">
                                                        <p><b>Age</b> : {passenger.age}</p>
                                                    </div>
                                                    <div className="cell">
                                                        <p><b>Weight</b> : {passenger.weight} kg.</p>
                                                    </div>
                                                    <div className="cell">
                                                        <p><b>Nationality</b> : {passenger.nationality}</p>
                                                    </div>
                                                </div>
                                            </div>
                                        )
                                    })
                                }
                                
                            </div>
                        </div>
                        <div className="column one" align="left">
                            <span className="form-label">Other Requirements / Notes <span className="required" title="required"></span></span> 
                            <p>{reviewData.note}</p>
                        </div>
                        <div className="column one" align="right">
                            <div className="table">
                                <div className="row">
                                <div className="cell"><span className="form-label">Total Price</span></div>
                                <div className="cell">{reviewData.bookinginfo.total_price.format(0,3,",")} THB</div>
                                </div>
                                <div className="row">
                            <div className="cell"><span className="form-label">Discount</span></div>
                            <div className="cell">{reviewData.bookinginfo.discount.format(0,3,",")} THB</div></div>
                                <div  className="row">
                            <div className="cell"><span className="form-label">Net Price</span></div>
                            <div className="cell">{reviewData.bookinginfo.price.format(0,3,",")} THB</div>
                            </div>
                            </div>
                        </div>

                        {
                            (!paypalApproved) && (
                                <div className="column one" align="center">
                                <PayPalButton
                                    createOrder={(data, actions) => this.createOrder(reviewData, actions)}
                                    onApprove={(data, actions) => this.onApprove(reviewData, actions)}
                                />
                                </div>
                            )
                        }
                        {
                            (paypalApproved) && (
                                <div className="column one" align="center">
                                <div className="wrap mcb-wrap mcb-wrap-x3yqe43r6 one valign-top bg-cover clearfix">
                                    <div className="mcb-wrap-inner">
                                        <div className="column mcb-column one column_column">
                                            <div className="column_attr clearfix align_center">
                                                <h2>Thank you for your booking</h2>
                                                <p className="big">
                                                Please check your email for booking confirmation
                                                </p>
                                            </div>
                                        </div>
										
										
                                    </div>
                                </div>
                                </div>
                            )
                        }
                        
                        
                </div>
            )
        }
    }
}
const domContainer = document.querySelector('#contactWrapper');
ReactDOM.render(e(Booking), domContainer);
/*{
                        fullname : "Direk Prama2",
                        age : 39,
                        weight : 70,
                        nationality : "Thai"
                    }*/